#install.packages("isotone")
#library(isotone)


# bandwidth selection for covariate x given grid # m=500 and bin width bin=0.1
# install.packages("KernSmooth")
#library(KernSmooth)


# kh : kernel density function will produce the weight based on the Z covariate
Kh <- function(ci,h,t)            
 {
  n	<- length(ci)
  temp<- (1/h)*(dnorm((ci-t)/h))
  k	<- c(temp[-n],temp[n-1]) #ifelse(n>1,c(temp[-n],temp[n-1]),temp)
  return(k=k)
 }

# fix : round counting process up to 10 decimal places and force it to be positive
fix <- function(x)        
 {
 x <- round(x,digits = 10) 
 if(length(which(x<0)>0))x[which(x<0)]<-0
 return(x)
 }

# comp : return the index, good for comparisons between vectors
comp <- function(x,y){min(which(abs(x-y)==min(abs(x-y))))}

# Function to handle cases where dpik() is unable to estimate
# a bandwidth, usually because a data vector has an interquartile range of 0.
dpikSafe <- function(x, ...)
{
	result <- try(dpik(x, ...), silent = TRUE)

	if (class(result) == "try-error")
	{
		msg <- geterrmessage()
		if (grepl("scale estimate is zero for input data", msg))
		{
			warning("Using standard deviation as scale estimate, probably because IQR == 0")
			result <- dpik(x, scalest = "stdev", ...)	
		} else 
		{
			stop(msg)
		}		
		
	}
	return(result)
} 


# function to calculate the counting process and at risk set pool for three states tracking model 1-2-3-4

dN <- function(ci,si,Z,Z_a,size,M,Tmax,h_t,h_Z)
       {
   		fine_grid <- seq(from=0,to=Tmax,bin)
  		m_f <- length(fine_grid)
  		gc  <- round(apply(outer(fine_grid,ci,Kh,h=h_t),1,mean),d=10)

            # The following if{}else{} codes define the smooth function for marginal only
             # marginal with 1/n_i cluster size adjustment (weight only) 
             # regression on Z. Z only
             # regression with both Z and scluster size
             # Z_a stands for an example of Z, one value
             # weight at Z_a incorporate inofrmative cluster size as 1/size if size is used
             # h_Z bandwidth for kernel smooth based on Covariates 


         #if (!length(Z)<length(ci)){ Z_1 <- rep(0,length(unique(M))) #if (!unique(!Z))
          #                 for (i in 1:length(unique(M))){
          #                                    Z_1[i] <-sample(Z[M==unique(M)[i]],1)
           #                                    }
          #                 h_Z <- dpik(Z_1,gridsize=length(ci))
          #                } 

         if (length(Z)<length(ci)){ ifelse (unique(!size), weight<-rep(1, length(ci)), weight <- 1/size ) #if (unique(!Z))
                                        } else   { # h_Z <- ((length(ci)/M)^0.2)*dpik(Z,gridsize=length(ci))#^0.5 #,range=z.range)
           		                                  if (unique(!size)){ weight <- apply(as.matrix(Z),2,Kh,h=h_Z,t=Z_a)
               		                                              } else { weight <- (1/size)*as.numeric(apply(as.matrix(Z),2,Kh,h=h_Z,t=Z_a))			     
                     		                                               }
                                                 }
          if ( sum(weight==0)>0 ) weight[weight==0] <-  min(weight[which(weight!=0)])


	   # smoothed version of counting processes 
            
         if( unique(!size) ){		gc <- round(apply(outer(fine_grid,ci,Kh,h=h_t),1,mean),d=8)
                             smooth <- function(x)outer(fine_grid,ci,Kh,h=h_t)%*%gpava(ci,x,weight)$x/gc                           
               }else {gc <- round(outer(fine_grid,ci,Kh,h=h_t)%*%(1/size)/length(ci),d=8)
                       smooth <- function(x)outer(fine_grid,ci,Kh,h=h_t)%*%((1/size)*gpava(ci,x,weight)$x)/gc
           }

		N12 <- smooth(si>=2) # estimate of counting process
		N23 <- smooth(si>=3)
		N34 <- smooth(si==4)

		# smoothed version of at risk set
            gc_Z <-  round((outer(fine_grid,ci,Kh,h=h_t)%*%weight)/length(ci),d=8) # used when consider phi smoothing
            smooth.risk<- function(x)outer(fine_grid,ci,Kh,h=h_t)%*%(-gpava(ci,-x,weight)$x*weight)/gc_Z

		Y1 <- smooth.risk(si==1)
		Y2 <- smooth.risk(si==2)
		Y3 <- smooth.risk(si==3)
      
	   list(N12=N12,N23=N23,N34=N34,fine_grid =fine_grid,gc=gc,gc_Z=gc_Z,m_f=m_f,Y1=Y1,Y2=Y2,Y3=Y3)
        } 

PLE <- function(ci,si,w,t)
        {
		Pool <- function(w,t)
			   {
				grid <- seq(0,t,length=m)
				index<-apply(matrix(grid,m,1),1,comp,w$fine_grid)

				grid<-w$fine_grid[index]
				N12<-w$N12[index]; N34<-w$N34[index]; N23<-w$N23[index]
				gc <-w$gc[index]; gc_Z<-w$gc_Z[index]


		 	dN12<-fix(diff(N12)); dN23<-fix(diff(N23)); dN34<-fix(diff(N34))

				y1 <- w$Y1[index]; y2 <- w$Y2[index]; y3 <- w$Y3[index]
					#if  ( sum(gc==0)>0 )   y1[which(gc==0)]<-0 
					#if  ( sum(gc==0)>0 )   y2[which(gc==0)]<-0 
					#if  ( sum(gc==0)>0 )   y3[which(gc==0)]<-0
					if  ( sum(gc_Z==0)>0 )   y1[which(gc_Z==0)]<-0 
					if  ( sum(gc_Z==0)>0 )   y2[which(gc_Z==0)]<-0 
					if  ( sum(gc_Z==0)>0 )   y3[which(gc_Z==0)]<-0 

				quot12 <- dN12/y1[-m]			
					if ( sum(y1[-m]==0)>0 )   quot12[which(y1[-m]==0)]<-0
					if ( sum(quot12 >1)>0 )   quot12[which(quot12>1)]<-1
			
				quot23 <- dN23/y2[-m]
					if ( sum(y2[-m]==0)>0 )   quot23[which(y2[-m]==0)]<-0  
					if ( sum(quot23>1)>0 )    quot23[which(quot23>1)]<-1 

				quot34 <- dN34/y3[-m]     
					if ( sum(y3[-m]==0)>0 )  quot34[which(y3[-m]==0)]<-0  
					if ( sum(quot34>1)>0 )   quot34[which(quot34>1)]<-1 

				temp2 <- exp(c(0,cumsum(quot23))[-m]-sum(quot23))
				temp3 <- exp(c(0,cumsum(quot34))[-m]-sum(quot34))

				P1 <- exp(-cumsum(quot12))
		
				list(dN12=dN12,dN23=dN23,dN34=dN34,grid=grid,P1=P1,quot12=quot12,
                             quot23=quot23,quot34=quot34,temp2=temp2, temp3=temp3,y1=y1,y2=y2,y3=y3)
	                }

		
		# Extract values for (0,max(Ci+2)) with m=500 using closest time grid (fine_grid) from dN 

		# Use fixed timegrid

            ifelse(t < 60,ti_dat <- seq(10,t,by=1),ti_dat <- seq(10,60,by=1)) 
 
		ti <-seq(0,max(ti_dat),length=m) 

		iter <- 0
	      P1   <- NULL
	    	temp2mat  <- temp3mat  <- matrix(0,(m-1),m-1)
		quot12mat <- quot23mat <- quot34mat <- matrix(0,(m-1),m-1)
		
		for (i in 1:(m-1))
			{ 
			 s <- Pool(w,ti[i])
			 quot12mat[,i] <- s$quot12; quot23mat[,i] <- s$quot23; quot34mat[,i] <- s$quot34
			 temp2mat[,i] <- s$temp2; temp3mat[,i] <- s$temp3;   
     			 P1[i] <- s$P1[m-1]
     			 iter <- iter+1
			 cat("iter=",iter,"\n")
			}

 	  	# Construct mxm matrix of time grids to get integrals. Use comp to get the real P1

 		t_grid <- apply(matrix(seq(0,max(ti_dat),l=m-1),nrow=m-1),1,seq,from=0,l=(m-1))

 		P1_mat <- P2_mat <- P3_mat <- I <- matrix(0,m-1,m-1)

 	 	for (i in 1:(m-1))
 			{
 		 	 I[,i] <- apply(matrix(t_grid[,i],nrow=m-1),1,comp,ti[-m])
 		 	 P1_mat[,i] <- P1[I[,i]]
 		 	}

  		P2 <- P3 <- NULL
 		 for (j in 1:(m-1)) { P2[j] <- sum(temp2mat[,j]*P1_mat[,j]*quot12mat[,j])}
             P2 <- ifelse(P2>1,1,P2)
 		 for (i in 1:(m-1)) { P2_mat[,i] <- P2[I[,i]]}


      	 for (j in 1:(m-1)) { P3[j] <- sum(temp3mat[,j]*P2_mat[,j]*quot23mat[,j])}
             P3 <- ifelse(P3>1,1,P3)
      	 for (i in 1:(m-1)) { P3_mat[,i] <- P3[I[,i]]}

 		P4 <- cumsum(P3*quot34mat[,m-1])
		
		# state entry and exit time distributions
		# G1 <- (P2+P3+P4)
		G1 <- F2 <- (P2+P3+P4)/((P2+P3+P4)[m-1])
            F2 <- ifelse(F2>1,1,F2)
             
		G2 <- F3 <- (P3+P4)/(P3[m-1]+P4[m-1])
            F3 <- ifelse(F3>1,1,F3)
		G3 <- F4 <- P4/(P4[m-1])
            ifelse(F4>1,1,F4)
    

      	grid  <- s$grid

       	n     <- length(ti_dat)
      	index <- apply(matrix(ti_dat,n,1),1,comp,y=grid[-m])            

            P1_dat=P1[index];P2_dat=P2[index];P3_dat=P3[index];P4_dat=P4[index]
            F2_dat=F2[index];F3_dat=F3[index];F4_dat=F4[index]

  	MAT <- cbind(P1_dat,P2_dat,P3_dat,P4_dat,F2_dat,F3_dat,F4_dat)
  	colnames(MAT)<- c("P1","P2","P3","P4","F2","F3","F4")

  	list(MAT=MAT,grid=grid[-m],si=si,ci=ci,P1=P1,P2=P2,P3=P3,P4=P4,F2=F2,F3=F3,F4=F4)
   }

### Functions for L1 distance (Mean Absolute Distance) ###
	
## Function for L1 distance i.e. mean absolute distance

	MAD <- function (ci1,si1,Z,Z_a,size,ID,Tmax,h_t,h_Z,t)
		
		 {
              #####################################
		  # weighted marginal
		  #####################################		  	
		   w1 <- dN(ci1,si1,Z=FALSE,Z_a=FALSE,size,ID,Tmax,h_t,h_Z)

		   ## The state occupation, entry and exit times distribution 
		   temp1 <- PLE(ci1,si1,w1,t)

		  ######################################
		  # weighted with covariate X adjustment
		  ######################################  		  

		   w2 <- dN(ci1,si1,Z,Z_a,size,ID,Tmax,h_t,h_Z)

		   ## PLE 

		   temp2 <- PLE(ci1,si1,w2,t)

		   ## Get the test statistics at fixed time points from 10 to t by 1 year ##

		   ##################################
		   #Test statistics from L1 distances
		   ##################################

		   delta <- apply(abs(temp1$MAT-temp2$MAT),2,mean)

 		   return(delta)
	    	 } 




